namespace ElectricLocomotive
{
    public partial class ElectricLocomotive : Form
    {
        private DrawingElectricLocomotive? _drawingElectricLocomotive;
        public ElectricLocomotive()
        {
            InitializeComponent();
        }

        private void Draw()
        {
            if (_drawingElectricLocomotive == null)
            {
                return;
            }
            Bitmap bmp = new(pictureBoxElectricLocomotive.Width, pictureBoxElectricLocomotive.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _drawingElectricLocomotive.DrawTransport(gr);
            pictureBoxElectricLocomotive.Image = bmp;
        }

        private void buttonCreate_Click(object sender, EventArgs e)
        {
            Random rnd = new Random();
            _drawingElectricLocomotive = new DrawingElectricLocomotive();
            _drawingElectricLocomotive.Init(rnd.Next(100, 300), rnd.Next(1000, 3000), 
                Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)),
                Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)),
                Convert.ToBoolean(rnd.Next(0, 2)), Convert.ToBoolean(rnd.Next(0, 2)),
                pictureBoxElectricLocomotive.Width, pictureBoxElectricLocomotive.Height);
            _drawingElectricLocomotive.SetPosition(rnd.Next(10, 100), rnd.Next(10, 100));
            Draw();
        }

        private void buttonMove_Click(object sender, EventArgs e)
        {
            if (_drawingElectricLocomotive == null)
            {
                return;
            }
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _drawingElectricLocomotive.MoveTransport(DirectionType.Up);
                    break;
                case "buttonDown":
                    _drawingElectricLocomotive.MoveTransport(DirectionType.Down);
                    break;
                case "buttonLeft":
                    _drawingElectricLocomotive.MoveTransport(DirectionType.Left);
                    break;
                case "buttonRight":
                    _drawingElectricLocomotive.MoveTransport(DirectionType.Right);
                    break;
            }
            Draw();
        }
    }
}